package com.janbrus.damian.pokladna.Adapters;

import android.content.Context;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.janbrus.damian.pokladna.Models.Product;
import com.janbrus.damian.pokladna.R;

import java.util.ArrayList;

/**
 * Created by jbrus on 30.1.2018.
 */
public class ProductsAdapter extends ArrayAdapter<Product> {

    private Context mContext;
    private ArrayList<Product> products;

    public ProductsAdapter(Context context, ArrayList<Product> products) {
        super(context, R.layout.product);
        this.mContext = context;
        this.products = products;
    }

    @Override
    public int getCount() {
        return 0;
    }

    @Override
    public long getItemId(int i) {
        return 0;
    }

    @Override
    public View getView(int position, View view, ViewGroup viewGroup) {
        View itemView = view;
        ViewHolder holder = null;

        if (itemView == null)
        {
            final LayoutInflater layoutInflater =
                    (LayoutInflater) mContext.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            itemView = layoutInflater.inflate(R.layout.product, viewGroup, false);

            holder = new ViewHolder();
            //holder.imgItem = (ImageView) itemView.findViewById(R.id.imgItem);
            holder.txtItem = (TextView) itemView.findViewById(R.id.txtItem);
            itemView.setTag(holder);
        }
        else
        {
            holder = (ViewHolder) itemView.getTag();
        }

        Product p = getItem(position);
        //holder.imgItem.setImageDrawable(item.getImage());
        holder.txtItem.setText(p.getName());

        return itemView;
    }

    // Provide a reference to the views for each data item
    // Complex data items may need more than one view per item, and
    // you provide access to all the views for a data item in a view holder
    /*public static class ViewHolder extends RecyclerView.ViewHolder {
        // each data item is just a string in this case
        public LinearLayout mTextView;
        public ViewHolder(LinearLayout v) {
            super(v);
            mTextView = v;
        }
    }*/
    static class ViewHolder
    {
        //ImageView imgItem;
        TextView txtItem;
    }

    public void swapData(ArrayList<Product> newProducts) {
        this.products = newProducts;
        notifyDataSetChanged();
    }
}
