package com.janbrus.damian.pokladna.Models

import android.arch.lifecycle.MutableLiveData
import android.arch.lifecycle.ViewModel
import android.arch.lifecycle.ViewModelProviders
import android.content.Context
import android.support.v4.app.FragmentActivity

import com.janbrus.damian.pokladna.Network.AsyncJsonResponse
import com.janbrus.damian.pokladna.Network.Webservice

import org.json.JSONException

import java.util.ArrayList
import javax.inject.Inject

/**
 * Created by Honza on 14.02.2018.
 */

class ProductsViewModel : ViewModel(), AsyncJsonResponse {

    var products: MutableLiveData<ArrayList<Product>> = MutableLiveData<ArrayList<Product>>()
    var context: Context? = null
    @Inject
    var webService: Webservice? = Webservice()

    fun selectProduct(p: Product) {
        if (!products!!.value!!.contains(p)) {
            products.value!!.add(0, p)
        } else {
            val pindex = products.value!!.indexOf(p)
            val product = products.value!![pindex]
            product.increaseCount()
        }
    }

    operator fun get(position: Int): Product {
        return products!!.value!![position]
    }

    fun getProductCount(p: Product): Int {
        val pindex = products!!.value!!.indexOf(p)
        return products.value!![pindex].count
    }

    fun length(): Int {
        return products!!.value!!.size
    }

    fun loadProducts() {
        webService!!.delegate = this
        webService!!.getProductsJson(context, "aaaaaa")
    }

    override fun onResponse(downloadedProducts: ArrayList<Product>) {
        products.value = downloadedProducts
    }

    companion object{
        fun create(activity: FragmentActivity): ProductsViewModel{
            var productDetailViewModel = ViewModelProviders.of(activity).get(ProductsViewModel::class.java)
            productDetailViewModel.context = activity.applicationContext
            return productDetailViewModel
        }
    }
}
