package com.janbrus.damian.pokladna.Network;

import android.content.Context;
import android.util.Log;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonArrayRequest;
import com.android.volley.toolbox.Volley;
import com.janbrus.damian.pokladna.ContextProvider;
import com.janbrus.damian.pokladna.Models.Product;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;

import javax.inject.Singleton;

import dagger.Component;

/**
 * Created by Honza on 21.01.2018.
 */
@Singleton
public class Webservice {

    private static final String API_URL = "http://janbrus.cz/eet2/pages/apitest.php";
    public AsyncJsonResponse delegate = null;
    private ArrayList<Product> productsCache = null;

    public void getProductsJson(Context context, String userKey) {

        if (productsCache != null) {
            delegate.onResponse(productsCache);
            return;
        }
        // Instantiate the RequestQueue.
        RequestQueue queue = Volley.newRequestQueue( context );
        //Log.i("---", "hikizgtf");
        JsonArrayRequest jsonRequest = new JsonArrayRequest
                (Request.Method.GET, getUrlWithParams(), null, new Response.Listener<JSONArray>() {
                    @Override
                    public void onResponse(JSONArray response) {
                        if (response == null) return;
                        try {
                            ArrayList<Product> plist = new ArrayList<Product>();
                            for (int i = 0; i < response.length(); i++) {
                                JSONObject jsonObject = response.getJSONObject(i);
                                Product product = new Product(jsonObject.getInt("id"), jsonObject.getString("name"), jsonObject.getDouble("price"));
                                plist.add(product);
                            }
                            delegate.onResponse(plist);
                            productsCache = plist;
                        } catch (JSONException e) {
                            // swallow json exception
                            Log.d("Json Exception ignored",e.toString());
                        }

                    }
                }, new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        error.printStackTrace();
                    }
                });


        // Add the request to the RequestQueue.
        queue.add(jsonRequest);
    }

    private static String getUrlWithParams() {
        return API_URL + "?products&key=bbbbbbbb";
    }

}
