<?php
	/**
	* @author Jan Brus
	*/
	class User 
	{
		// Private property to handle database connection
		private $_db;
		public function __construct()
		{
			$this->_db = Database::getInstance();
		}
		
		/**
		* Method to handle user login and check if login is true 
		*/
		public function login($username, $password)
		{
			$query = $this->_db->query("
				SELECT u.id as userid,u.hash as userhash, u.username, u.created AS user_created, u.email, p.id as possystem_id, p.name as possystem_name, p.created AS possystem_created
				FROM `users` u
				JOIN `possystem` p ON p.user_id = u.id
				WHERE username = ? AND password = ?", array($username, md5($password)));
			if ($query->count() > 0) {
				$userData = array(
					'userid' => $query->results()[0]->userid,
					'userhash' => $query->results()[0]->userhash,
					'username' => $query->results()[0]->username,
					'user_created' => $query->results()[0]->user_created,
					'email' => $query->results()[0]->email,
					'possystem_id' => $query->results()[0]->possystem_id,
					'possystem_name' => $query->results()[0]->possystem_name,
					'possystem_created' => $query->results()[0]->possystem_created
				);
				$_SESSION['user_session'] = $userData;
				return $query->results()[0]->userhash;
			}
			return false;
		}
		/**
		* Public Static Method to store user session if logged in
		*/
		public static function isLoggedIn()
		{
			if(isset($_SESSION['user_session']))
			{
				return $_SESSION['user_session'];
			}
		}
		/**
		* Public Method to handle users logout
		*/
		public static function logout()
		{
			if (session_status() == PHP_SESSION_ACTIVE) {
				session_destroy();
				unset($_SESSION['user_session']);
			}
			return true;
		}
	}
?>