<?php
	$section = 'product_edit';
	include '../core/auth.php';
    require_once '../core/init.php';
	$formActionLink = productEdit;
	if (isset($_POST['name'])) 
	{
		$name = Input::cleanData($_POST["name"]);
		$type = Input::cleanData($_POST["type"]);
		$description = Input::cleanData($_POST["description"]);
		if (isset($_GET['id'])) {
			// update existing
			$action = 'edit';
			$x = new Product;
			if ($x->updateProduct($_GET['id'], $name, $type, $description))
			{
				Redirect::to(productList);
			}
		} else {
			// create new
			$action = 'create';
			$x = new Product;
			if ($x->createProduct(1, $name, $type, $description))
			{
				Redirect::to(productList);
			}
		}
	} else if (isset($_GET['id'])) {
		// only load existing
		$action = 'edit';
		$x = new Product;
		$productResult = $x->getProductById($_GET['id'])->results();
		$product = reset($productResult);
		if ($product != false) {			
			$name = $product->name;
			$type = $product->type;
			$description = $product->description;
		}
		$formActionLink = productEdit."?id=".$_GET['id'];
	}
	require_once header;
	
	require_once navigation;
?>
<div id="page-wrapper">
	<div class="row">
		<div class="col-md-12">
			<form action="<?php echo $formActionLink;?>" method="POST" role="form">
				<legend><h2><?php if ($action == 'create') echo 'Vytvořit produkt'; else if ($action == 'edit') echo 'Upravit produkt'; ?></h2></legend>
				<div class="form-group">
					<label for="name">Název produktu</label>
					<div class="input-group">
						<input type="text" class="form-control" id="name" name="name" placeholder="" value="<?php if(isset($name)){echo $name;}?>" required="required" />
					</div>
				</div>
			
			<div class="form-group">
					<label for="type">Typ produktu</label>
					<div class="input-group">
						<select id="type" name="type" class="form-control">
						<option value="1" <?php if ($type == 1) echo 'selected'; ?>>Potraviny</option>
						<option value="2" <?php if ($type == 2) echo 'selected'; ?>>Pečivo</option>
						<option value="3" <?php if ($type == 3) echo 'selected'; ?>>Nápoj</option>
						<option value="4" <?php if ($type == 4) echo 'selected'; ?>>Ovoce</option>
					</select>
					</div>
				</div>
				<div class="form-group">
					<label for="description">Popis produktu</label>
					<div class="input-group">
						<textarea name="description" rows="5" cols="50" placeholder=""><?php if(isset($description)){echo $description;}?></textarea> 
					</div>
				</div>
				<button type="submit" class="btn btn-info">Uložit</button>
			</form>
		</div>
	</div>
</div>
<?php
	require_once footer;
?>